/// <reference types="react" />
import * as History from "history";
import * as Redux from "redux";
import * as ReactRouterRedux from "react-router-redux";
declare namespace interfaces {
    interface ConfigureStore extends Function {
        (middlewares: Redux.Middleware[], rootReducer: Object, initialState: any): Redux.Store<any>;
    }
    interface BoostrapOptions {
        routes: JSX.Element;
        reducers: ReducersOption;
        createHistory?: History.CreateHistory<History.History>;
        historyOptions?: History.HistoryOptions;
        middlewares?: Redux.Middleware[];
        render?: Function;
        initialState?: any;
        container?: string;
    }
    interface BootstrapResult {
        store: Redux.Store<any>;
        history: ReactRouterRedux.ReactRouterReduxHistory;
        output: any;
        root: JSX.Element;
    }
    interface ReducersOption {
        [index: string]: Redux.Reducer<any>;
    }
    interface RootComponentProps {
        store: Redux.Store<any>;
        history: ReactRouterRedux.ReactRouterReduxHistory;
        routes: JSX.Element;
    }
    interface NodeModule {
        hot: {
            accept: (path: string, cb: () => void) => void;
        };
    }
}
export default interfaces;
